import map from "../map";
import find from "../find";
import mapParallel from "../mapParallel";
import filter from "../filter";
import reject from "../reject";
import { castArray } from "foundation-low";
class ChainWrapper {
    constructor(value) {
        this.castArray = () => {
            this._chainedPromises.push({
                operation: castArray
            });
            return this;
        };
        this.map = (func) => {
            this._chainedPromises.push({
                operation: map,
                func
            });
            return this;
        };
        this.mapParallel = (func) => {
            this._chainedPromises.push({
                operation: mapParallel,
                func
            });
            return this;
        };
        this.filter = (func) => {
            this._chainedPromises.push({
                operation: filter,
                func
            });
            return this;
        };
        this.find = (func) => {
            this._chainedPromises.push({
                operation: find,
                func
            });
            return this;
        };
        this.reject = (func) => {
            this._chainedPromises.push({
                operation: reject,
                func
            });
            return this;
        };
        this.value = async () => {
            let index = -1;
            const length = this._chainedPromises.length;
            while (++index < length) {
                const chainedPromises = this._chainedPromises[index];
                this._value = await chainedPromises.operation(this._value, chainedPromises.func);
            }
            return this._value;
        };
        this._value = value;
        this._chainedPromises = [];
    }
}
function chain(value) {
    return new ChainWrapper(value);
}
export default chain;
//# sourceMappingURL=index.js.map